# imports for required functionallity
import pytest

# test this module
import stacksplit


def test_static_10_2():
    expected = [(1, 9), (2, 8), (3, 7), (4, 6), (5, 5)]
    assert list(stacksplit.split(10, 2)) == expected


def test_static_10_2_m1():
    expected = [(-1, 11), (0, 10), (1, 9), (2, 8), (3, 7), (4, 6), (5, 5)]
    assert list(stacksplit.split(10, 2, -1)) == expected


def test_static_31_3():
    expected = [
        (1, 1, 29), (1, 2, 28), (1, 3, 27), (1, 4, 26), (1, 5, 25), (1, 6, 24), (1, 7, 23),
        (1, 8, 22), (1, 9, 21), (1, 10, 20), (1, 11, 19), (1, 12, 18), (1, 13, 17), (1, 14, 16),
        (1, 15, 15), (2, 2, 27), (2, 3, 26), (2, 4, 25), (2, 5, 24), (2, 6, 23), (2, 7, 22),
        (2, 8, 21), (2, 9, 20), (2, 10, 19), (2, 11, 18), (2, 12, 17), (2, 13, 16), (2, 14, 15),
        (3, 3, 25), (3, 4, 24), (3, 5, 23), (3, 6, 22), (3, 7, 21), (3, 8, 20), (3, 9, 19),
        (3, 10, 18), (3, 11, 17), (3, 12, 16), (3, 13, 15), (3, 14, 14), (4, 4, 23), (4, 5, 22),
        (4, 6, 21), (4, 7, 20), (4, 8, 19), (4, 9, 18), (4, 10, 17), (4, 11, 16), (4, 12, 15),
        (4, 13, 14), (5, 5, 21), (5, 6, 20), (5, 7, 19), (5, 8, 18), (5, 9, 17), (5, 10, 16),
        (5, 11, 15), (5, 12, 14), (5, 13, 13), (6, 6, 19), (6, 7, 18), (6, 8, 17), (6, 9, 16),
        (6, 10, 15), (6, 11, 14), (6, 12, 13), (7, 7, 17), (7, 8, 16), (7, 9, 15), (7, 10, 14),
        (7, 11, 13), (7, 12, 12), (8, 8, 15), (8, 9, 14), (8, 10, 13), (8, 11, 12), (9, 9, 13),
        (9, 10, 12), (9, 11, 11), (10, 10, 11)
    ]
    assert list(stacksplit.split(31, 3)) == expected


def test_static_31_3_9():
    expected = [(9, 9, 13), (9, 10, 12), (9, 11, 11), (10, 10, 11)]
    assert list(stacksplit.split(31, 3, 9)) == expected


def test_static_10_m1():
    with pytest.raises(ValueError):
        list(stacksplit.split(10, -1))
